(*#####################################################*)
(*#  Classes for Oberon Portable Compiler and Linker  #*)
(*#     ( https://sourceforge.net/projects/opcl )     #*)
(*# Version 1.0 for Win32: 9x,NT,Me,2k,XP,2k3,Vista,7 #*)
(*#  It is free for commercial & non-commercial use.  #*)
(*#                                                   #*)
(*# Copyright (C) 2011-2012, Serg Atantsov            #*)
(*#     e-mail Web_2.0@mail.ru     ICQ 200972129      #*)
(*#                                                   #*)
(*# Copyright (C) 2007-2012, Oleg N. Cher             #*)
(*#  www.zx.oberon2.ru e-mail allot@bk.ru ICQ 2208403 #*)
(*#####################################################*)

MODULE Classes;

IMPORT
  SYSTEM;

TYPE
	TObjectList* = POINTER TO RECORD
  	VAR
  	  Count*  : LONGINT;
  	  index   : LONGINT;
  		Str     : ARRAY 255 OF CHAR;
  		Obj     : SYSTEM.PTR;
  		next    : TObjectList;
		
		PROCEDURE &Init ();
    BEGIN
      next := NIL;
      Count:= 0;
      index:= 0;
    END Init;
    
    PROCEDURE Objects* (i: LONGINT): SYSTEM.PTR;
    VAR
      p: TObjectList;
    BEGIN
      p:=SELF;
      WHILE (p # NIL) & (p.index # i) DO p:=p.next; END;
      IF p=NIL THEN
        RETURN NIL;
      ELSE
        RETURN p.Obj;
      END;
    END Objects;
    
    PROCEDURE AddObject* (str: ARRAY OF CHAR; AObject: SYSTEM.PTR);
    VAR
      p,q: TObjectList;
    BEGIN
      p := SELF;
      WHILE (p.next # NIL) DO p := p.next END;
      NEW(q);
      COPY(str,q.Str);
      q.index:= index; 
      q.Obj  := AObject;
      q.next := p.next; 
      p.next := q;      
      INC(Count);
      INC(index);
    END AddObject;
    
	END;
	
	TStringList* = POINTER TO RECORD(TObjectList)
    
    PROCEDURE Strings* (i: LONGINT): ARRAY OF CHAR;
    VAR
      p: TObjectList;
      A: ARRAY 1 OF CHAR;
    BEGIN
      A[0]:=0X;
      p:=SELF;
      WHILE (p # NIL) & (p.index # i) DO p:=p.next; END;
      IF p=NIL THEN
        RETURN A;
      ELSE
        RETURN p.Str;
      END;
    END Strings;
   
    PROCEDURE Add* (str: ARRAY OF CHAR);
    BEGIN
      AddObject(str,NIL);
    END Add;
    
	END;

END Classes.