(*#####################################################*)
(*# Controls for Oberon Portable Compiler and Linker  #*)
(*#     ( https://sourceforge.net/projects/opcl )     #*)
(*# Version 1.0 for Win32: 9x,NT,Me,2k,XP,2k3,Vista,7 #*)
(*#  It is free for commercial & non-commercial use.  #*)
(*#                                                   #*)
(*# Copyright (C) 2011-2012, Serg Atantsov            #*)
(*#     e-mail Web_2.0@mail.ru     ICQ 200972129      #*)
(*#                                                   #*)
(*# Copyright (C) 2007-2012, Oleg N. Cher             #*)
(*#  www.zx.oberon2.ru e-mail allot@bk.ru ICQ 2208403 #*)
(*#####################################################*)

MODULE Controls;

IMPORT
  SYSTEM, W:=Windows, M:=Messages;

VAR
  ID*: LONGINT;
  
TYPE
  TControlList*       = POINTER TO RECORD
    Next*    : TControlList;
    Pointer* : SYSTEM.PTR;
    ID*      : LONGINT;
    
    PROCEDURE &Create;
    BEGIN
      Next:=NIL;
    END Create;
    
    PROCEDURE Find*(Owner: TWinControl; id : LONGINT): SYSTEM.PTR;
    VAR
      Result: SYSTEM.PTR;
      List  : TControlList;
    BEGIN
      Result:=NIL;
      List:=Next;
      WHILE (List#NIL) & (Result=NIL) DO
        IF (List.ID=id) & (List.Pointer(TWinControl).Owner=Owner) THEN
          Result:=List.Pointer;
        END;
        List:=List.Next;
      END;
      RETURN Result;
    END Find;
    
    PROCEDURE Add*(Owner: TWinControl; P : SYSTEM.PTR; id : LONGINT);
    VAR
      New   : TControlList;
    BEGIN
      IF Find(Owner,id)#NIL THEN RETURN END;
      NEW(New);
      New.Pointer:=P;
      New.Next:=Next;
      New.ID:=id;
      Next:=New;
    END Add;
    
  END;
  
  TWinControl*  = POINTER TO RECORD
    Handle*   : W.HWND;
    Left*     : LONGINT;
    Top*      : LONGINT;
    Width*    : LONGINT;
    Height*   : LONGINT;
    Caption*  : ARRAY 32 OF CHAR;
    SELF_ID*  : LONGINT;
    Owner*    : TWinControl;
    Style*    : SET;
    
    PROCEDURE & Create(Owner: TWinControl);
    BEGIN
      INC(ID);
      Left     := 0;
      Top      := 0;
      Width    := 100;
      Height   := 100;
      Caption  := '';
      SELF_ID  := ID;
      SELF.Owner := Owner;
      Style    := {};
      ControlList.Add(Owner,SELF,SELF_ID);
    END Create;
    
    PROCEDURE Update*;
    VAR
      S: ARRAY 32 OF CHAR;
    BEGIN
      W.GetWindowText(Handle,SYSTEM.ADR(S),LEN(S));
      IF S # Caption THEN 
        W.SetWindowText(Handle, SYSTEM.ADR(Caption));
      END;
      W.MoveWindow(Handle, Left,Top,Width,Height,0);
    END Update;
    
    PROCEDURE WindowProc*(msg,wParam,lParam: LONGINT);
    VAR
      R      : W.RECT;
    BEGIN
      CASE msg OF 
         M.WM_SIZE   :
                            W.GetClientRect(Handle,R);
                            Left   := R.left;
                            Top    := R.top;  
                            Width  := R.right-R.left;
                            Height := R.bottom-R.top; 
                            ReSize;
      |  M.WM_MOVE   :      
                            W.GetClientRect(Handle,R);
                            Left   := R.left;
                            Top    := R.top;
      ELSE
      END; 
    END WindowProc;
    
    PROCEDURE ReSize*;
    BEGIN
    END ReSize;
    
  END;

VAR
  ControlList*: TControlList;  
BEGIN
  NEW(ControlList); 
  ID:=0;  
END Controls.