(*#####################################################*)
(*#  Dialogs for Oberon Portable Compiler and Linker  #*)
(*#     ( https://sourceforge.net/projects/opcl )     #*)
(*# Version 1.0 for Win32: 9x,NT,Me,2k,XP,2k3,Vista,7 #*)
(*#  It is free for commercial & non-commercial use.  #*)
(*#                                                   #*)
(*# Copyright (C) 2011-2012, Serg Atantsov            #*)
(*#     e-mail Web_2.0@mail.ru     ICQ 200972129      #*)
(*#                                                   #*)
(*# Copyright (C) 2007-2012, Oleg N. Cher             #*)
(*#  www.zx.oberon2.ru e-mail allot@bk.ru ICQ 2208403 #*)
(*#####################################################*)

MODULE Dialogs;

IMPORT
  SYSTEM, W:=Windows;

CONST (* macros *)
	OFN_READONLY* = {0};
	OFN_OVERWRITEPROMPT* = {1};
	OFN_HIDEREADONLY* = {2};
	OFN_NOCHANGEDIR* = {3};
	OFN_SHOWHELP* = {4};
	OFN_ENABLEHOOK* = {5};
	OFN_ENABLETEMPLATE* = {6};
	OFN_ENABLETEMPLATEHANDLE* = {7};
	OFN_NOVALIDATE* = {8};
	OFN_ALLOWMULTISELECT* = {9};
	OFN_EXTENSIONDIFFERENT* = {10};
	OFN_PATHMUSTEXIST* = {11};
	OFN_FILEMUSTEXIST* = {12};
	OFN_CREATEPROMPT* = {13};
	OFN_SHAREAWARE* = {14};
	OFN_NOREADONLYRETURN* = {15};
	OFN_NOTESTFILECREATE* = {16};
	OFN_NONETWORKBUTTON* = {17};
	OFN_NOLONGNAMES* = {18};
	OFN_EXPLORER* = {19};
	OFN_NODEREFERENCELINKS* = {20};
	OFN_LONGNAMES* = {21};
	OFN_SHAREFALLTHROUGH* = 2;
	OFN_SHARENOWARN* = 1;
	OFN_SHAREWARN* = 0;
	
	CDN_INITDONE* = -601;
	CDN_SELCHANGE* = -602;
	CDN_FOLDERCHANGE* = -603;
	CDN_SHAREVIOLATION* = -604;
	CDN_HELP* = -605;
	CDN_FILEOK* = -606;
	CDN_TYPECHANGE* = -607;
	CDM_FIRST* = 1124;
	CDM_LAST* = 1224;
	CDM_GETSPEC* = 1124;
	CDM_GETFILEPATH* = 1125;
	CDM_GETFOLDERPATH* = 1126;
	CDM_GETFOLDERIDLIST* = 1127;
	CDM_SETCONTROLTEXT* = 1128;
	CDM_HIDECONTROL* = 1129;
	CDM_SETDEFEXT* = 1130;
	
	CC_RGBINIT* = {0};
	CC_FULLOPEN* = {1};
	CC_PREVENTFULLOPEN* = {2};
	CC_SHOWHELP* = {3};
	CC_ENABLEHOOK* = {4};
	CC_ENABLETEMPLATE* = {5};
	CC_ENABLETEMPLATEHANDLE* = {6};
	CC_SOLIDCOLOR* = {7};
	CC_ANYCOLOR* = {8};
	
	FR_DOWN* = {0};
	FR_WHOLEWORD* = {1};
	FR_MATCHCASE* = {2};
	FR_FINDNEXT* = {3};
	FR_REPLACE* = {4};
	FR_REPLACEALL* = {5};
	FR_DIALOGTERM* = {6};
	FR_SHOWHELP* = {7};
	FR_ENABLEHOOK* = {8};
	FR_ENABLETEMPLATE* = {9};
	FR_NOUPDOWN* = {10};
	FR_NOMATCHCASE* = {11};
	FR_NOWHOLEWORD* = {12};
	FR_ENABLETEMPLATEHANDLE* = {13};
	FR_HIDEUPDOWN* = {14};
	FR_HIDEMATCHCASE* = {15};
	FR_HIDEWHOLEWORD* = {16};
	
	CF_SCREENFONTS* = {0};
	CF_PRINTERFONTS* = {1};
	CF_BOTH* = {0, 1};
	CF_SHOWHELP* = {2};
	CF_ENABLEHOOK* = {3};
	CF_ENABLETEMPLATE* = {4};
	CF_ENABLETEMPLATEHANDLE* = {5};
	CF_INITTOLOGFONTSTRUCT* = {6};
	CF_USESTYLE* = {7};
	CF_EFFECTS* = {8};
	CF_APPLY* = {9};
	CF_ANSIONLY* = {10};
	CF_SCRIPTSONLY* = {10};
	CF_NOVECTORFONTS* = {11};
	CF_NOOEMFONTS* = {11};
	CF_NOSIMULATIONS* = {12};
	CF_LIMITSIZE* = {13};
	CF_FIXEDPITCHONLY* = {14};
	CF_WYSIWYG* = {15};
	CF_FORCEFONTEXIST* = {16};
	CF_SCALABLEONLY* = {17};
	CF_TTONLY* = {18};
	CF_NOFACESEL* = {19};
	CF_NOSTYLESEL* = {20};
	CF_NOSIZESEL* = {21};
	CF_SELECTSCRIPT* = {22};
	CF_NOSCRIPTSEL* = {23};
	CF_NOVERTFONTS* = {24};
	
	SIMULATED_FONTTYPE* = 32768;
	PRINTER_FONTTYPE* = 16384;
	SCREEN_FONTTYPE* = 8192;
	BOLD_FONTTYPE* = 256;
	ITALIC_FONTTYPE* = 512;
	REGULAR_FONTTYPE* = 1024;
	WM_CHOOSEFONT_GETLOGFONT* = 1025;
	
	LBSELCHSTRINGA* = "commdlg_LBSelChangedNotify";
	SHAREVISTRINGA* = "commdlg_ShareViolation";
	FILEOKSTRINGA* = "commdlg_FileNameOK";
	COLOROKSTRINGA* = "commdlg_ColorOK";
	SETRGBSTRINGA* = "commdlg_SetRGBColor";
	HELPMSGSTRINGA* = "commdlg_help";
	FINDMSGSTRINGA* = "commdlg_FindReplace";
	LBSELCHSTRINGW* = "commdlg_LBSelChangedNotify";
	SHAREVISTRINGW* = "commdlg_ShareViolation";
	FILEOKSTRINGW* = "commdlg_FileNameOK";
	COLOROKSTRINGW* = "commdlg_ColorOK";
	SETRGBSTRINGW* = "commdlg_SetRGBColor";
	HELPMSGSTRINGW* = "commdlg_help";
	FINDMSGSTRINGW* = "commdlg_FindReplace";
	LBSELCHSTRING* = "commdlg_LBSelChangedNotify";
	SHAREVISTRING* = "commdlg_ShareViolation";
	FILEOKSTRING* = "commdlg_FileNameOK";
	COLOROKSTRING* = "commdlg_ColorOK";
	SETRGBSTRING* = "commdlg_SetRGBColor";
	HELPMSGSTRING* = "commdlg_help";
	FINDMSGSTRING* = "commdlg_FindReplace";
	
	CD_LBSELNOITEMS* = -1;
	CD_LBSELCHANGE* = 0;
	CD_LBSELSUB* = 1;
	CD_LBSELADD* = 2;
	
	PD_ALLPAGES* = {};
	PD_SELECTION* = {0};
	PD_PAGENUMS* = {1};
	PD_NOSELECTION* = {2};
	PD_NOPAGENUMS* = {3};
	PD_COLLATE* = {4};
	PD_PRINTTOFILE* = {5};
	PD_PRINTSETUP* = {6};
	PD_NOWARNING* = {7};
	PD_RETURNDC* = {8};
	PD_RETURNIC* = {9};
	PD_RETURNDEFAULT* = {10};
	PD_SHOWHELP* = {11};
	PD_ENABLEPRINTHOOK* = {12};
	PD_ENABLESETUPHOOK* = {13};
	PD_ENABLEPRINTTEMPLATE* = {14};
	PD_ENABLESETUPTEMPLATE* = {15};
	PD_ENABLEPRINTTEMPLATEHANDLE* = {16};
	PD_ENABLESETUPTEMPLATEHANDLE* = {17};
	PD_USEDEVMODECOPIES* = {18};
	PD_USEDEVMODECOPIESANDCOLLATE* = {18};
	PD_DISABLEPRINTTOFILE* = {19};
	PD_HIDEPRINTTOFILE* = {20};
	PD_NONETWORKBUTTON* = {21};
	
	DN_DEFAULTPRN* = 1;
	WM_PSD_PAGESETUPDLG* = 1024;
	WM_PSD_FULLPAGERECT* = 1025;
	WM_PSD_MINMARGINRECT* = 1026;
	WM_PSD_MARGINRECT* = 1027;
	WM_PSD_GREEKTEXTRECT* = 1028;
	WM_PSD_ENVSTAMPRECT* = 1029;
	WM_PSD_YAFULLPAGERECT* = 1030;
	
	PSD_DEFAULTMINMARGINS* = {};
	PSD_INWININIINTLMEASURE* = {};
	PSD_MINMARGINS* = {0};
	PSD_MARGINS* = {1};
	PSD_INTHOUSANDTHSOFINCHES* = {2};
	PSD_INHUNDREDTHSOFMILLIMETERS* = {3};
	PSD_DISABLEMARGINS* = {4};
	PSD_DISABLEPRINTER* = {5};
	PSD_NOWARNING* = {7};
	PSD_DISABLEORIENTATION* = {8};
	PSD_RETURNDEFAULT* = {10};
	PSD_DISABLEPAPER* = {9};
	PSD_SHOWHELP* = {11};
	PSD_ENABLEPAGESETUPHOOK* = {13};
	PSD_ENABLEPAGESETUPTEMPLATE* = {15};
	PSD_ENABLEPAGESETUPTEMPLATEHANDLE* = {17};
	PSD_ENABLEPAGEPAINTHOOK* = {18};
	PSD_DISABLEPAGEPAINTING* = {19};
	PSD_NONETWORKBUTTON* = {21};

TYPE
  OFNHOOKPROC*         = PROCEDURE [WINAPI] (p0: W.HWND; p1: LONGINT; p2: W.WPARAM; p3: W.LPARAM): LONGINT;
	OPENFILENAMEA*       = RECORD [NOTALIGN]
		lStructSize*: LONGINT;
		hwndOwner*: W.HWND;
		hInstance*: W.HINSTANCE;
		lpstrFilter*: W.PtrSTR;
		lpstrCustomFilter*: W.PtrSTR;
		nMaxCustFilter*: LONGINT;
		nFilterIndex*: LONGINT;
		lpstrFile*: W.PtrSTR;
		nMaxFile*: LONGINT;
		lpstrFileTitle*: W.PtrSTR;
		nMaxFileTitle*: LONGINT;
		lpstrInitialDir*: W.PtrSTR;
		lpstrTitle*: W.PtrSTR;
		Flags*: SET;
		nFileOffset*: INTEGER;
		nFileExtension*: INTEGER;
		lpstrDefExt*: W.PtrSTR;
		lCustData*: W.LPARAM;
		lpfnHook*: OFNHOOKPROC;
		lpTemplateName*: W.PtrSTR;
	END;
	PtrOPENFILENAMEA* = POINTER TO OPENFILENAMEA;

  CCHOOKPROC*   = PROCEDURE [WINAPI] (p0: W.HWND; p1: LONGINT; p2: W.WPARAM; p3: W.LPARAM): LONGINT;
  CHOOSECOLORA* = RECORD [NOTALIGN]
		lStructSize*: LONGINT;
		hwndOwner*: W.HWND;
		hInstance*: W.HWND;
		rgbResult*: W.COLORREF;
		lpCustColors*: LONGINT;
		Flags*    : SET;
		lCustData*: W.LPARAM;
		lpfnHook* : CCHOOKPROC;
		lpTemplateName*: W.PtrSTR;
	END;
	PtrCHOOSECOLORA* = POINTER TO CHOOSECOLORA;
	
	CFHOOKPROC*  = PROCEDURE [WINAPI] (p0: W.HWND; p1: LONGINT; p2: W.WPARAM; p3: W.LPARAM): LONGINT;
  CHOOSEFONTA* = RECORD [NOTALIGN]
		lStructSize*: LONGINT;
		hwndOwner*: W.HWND;
		hDC*: W.HDC;
		lpLogFont*: LONGINT;
		iPointSize*: LONGINT;
		Flags*: SET;
		rgbColors*: W.COLORREF;
		lCustData*: W.LPARAM;
		lpfnHook*: CFHOOKPROC;
		lpTemplateName*: W.PtrSTR;
		hInstance*: W.HINSTANCE;
		lpszStyle*: W.PtrSTR;
		nFontType*: INTEGER;
		___MISSING_ALIGNMENT__*: INTEGER;
		nSizeMin*: LONGINT;
		nSizeMax*: LONGINT;
	END;
	PtrCHOOSEFONTA* = POINTER TO CHOOSEFONTA;
  
  PRINTHOOKPROC*   = PROCEDURE [WINAPI] (p0: W.HWND; p1: LONGINT; p2: W.WPARAM; p3: W.LPARAM): LONGINT;
	SETUPHOOKPROC*   = PROCEDURE [WINAPI] (p0: W.HWND; p1: LONGINT; p2: W.WPARAM; p3: W.LPARAM): LONGINT;
  PRINTDLGA* = RECORD [NOTALIGN]
		lStructSize*: LONGINT;
		hwndOwner*: W.HWND;
		hDevMode*: W.HGLOBAL;
		hDevNames*: W.HGLOBAL;
		hDC*: W.HDC;
		Flags*: SET;
		nFromPage*: INTEGER;
		nToPage*: INTEGER;
		nMinPage*: INTEGER;
		nMaxPage*: INTEGER;
		nCopies*: INTEGER;
		hInstance*: W.HINSTANCE;
		lCustData*: W.LPARAM;
		lpfnPrintHook*: PRINTHOOKPROC;
		lpfnSetupHook*: SETUPHOOKPROC;
		lpPrintTemplateName*: W.PtrSTR;
		lpSetupTemplateName*: W.PtrSTR;
		hPrintTemplate*: W.HGLOBAL;
		hSetupTemplate*: W.HGLOBAL;
	END;
	PtrPRINTDLGA* = POINTER TO PRINTDLGA;
      	
  TOpenDialog* = POINTER TO RECORD
  VAR
    FileName*    : ARRAY 256 OF CHAR;
    Filter*      : ARRAY 256 OF CHAR;
    Ext*         : ARRAY 10  OF CHAR;     
    FilterIndex* : LONGINT;
    
    DlgRec       : OPENFILENAMEA;
    
    PROCEDURE &Create*(AOwner: SYSTEM.PTR);
    BEGIN
      FileName[0] := 0X;
      FilterIndex := 1;
    END Create;
   
    PROCEDURE Convert (VAR a: ARRAY OF CHAR);
    VAR
      i: LONGINT;
    BEGIN
      i := 0;
      WHILE a[i] # 0X DO
        IF a[i]='|' THEN a[i]:=0X END; 
        INC(i);  
      END;
    END Convert;

    PROCEDURE FillRec();
    BEGIN
      DlgRec.lStructSize := SIZE(OPENFILENAMEA);
      DlgRec.hwndOwner   := 0;
      DlgRec.hInstance   := 0;
      DlgRec.nFilterIndex:= FilterIndex; 
      DlgRec.lpstrFilter := SYSTEM.ADR(Filter);
      DlgRec.lpstrFile   := SYSTEM.ADR(FileName);
      DlgRec.nMaxFile    := LEN(FileName);
      DlgRec.Flags       := OFN_EXPLORER + OFN_HIDEREADONLY;
      DlgRec.lpstrDefExt := SYSTEM.ADR(Ext);
    END FillRec;
    
    PROCEDURE Execute* (): BOOLEAN;
    BEGIN
      Convert(Filter);
      FillRec();
      IF GetOpenFileName(DlgRec)#0 THEN
        RETURN TRUE;
      ELSE
        RETURN FALSE;
      END;
    END Execute;
    
  END;
  
  TSaveDialog* = POINTER TO RECORD(TOpenDialog)
  
    PROCEDURE &Create*(AOwner: SYSTEM.PTR);
    BEGIN
      Create^(AOwner);
    END Create;
    
    PROCEDURE Execute* (): BOOLEAN;
    BEGIN
      Convert(Filter);
      FillRec^();
      IF GetSaveFileName(DlgRec)#0 THEN
        RETURN TRUE;
      ELSE
        RETURN FALSE;
      END;
    END Execute;
      
  END;
  
  TColorDialog* = POINTER TO RECORD
    VAR
      Color*    : LONGINT;
      ColorRec  : CHOOSECOLORA; 
      acrCustClr: ARRAY 16 OF W.COLORREF;
      
    PROCEDURE &Create*(AOwner: SYSTEM.PTR);
    BEGIN
      ColorRec.lStructSize   := SIZE(CHOOSECOLORA);
      ColorRec.hwndOwner     := 0;
      ColorRec.lpCustColors  := SYSTEM.ADR(acrCustClr);
      ColorRec.rgbResult     := Color;
      ColorRec.Flags         := CC_FULLOPEN + CC_RGBINIT;
    END Create;
    
    PROCEDURE Execute* (): BOOLEAN;
    BEGIN
      IF ChooseColor(ColorRec)#0 THEN
        Color := ColorRec.rgbResult;
        RETURN TRUE;
      ELSE
        RETURN FALSE;
      END;
    END Execute;
      
  END;
  
  TFontDialog* = POINTER TO RECORD
    VAR
      Font*      : W.HFONT;
      FontName*  : ARRAY 32 OF CHAR;
      Color*     : LONGINT;
      
      FontRec    : CHOOSEFONTA; 
      LogFont    : W.LOGFONTA;
        
    PROCEDURE &Create*(AOwner: SYSTEM.PTR);
    BEGIN
      FontRec.lStructSize := SIZE(CHOOSEFONTA);
      FontRec.hwndOwner   := 0;
      FontRec.lpLogFont   := SYSTEM.ADR(LogFont);
      FontRec.rgbColors   := Color;
      FontRec.Flags       := CF_SCREENFONTS + CF_EFFECTS;
    END Create;
    
    PROCEDURE Execute* (): BOOLEAN;
    BEGIN
      IF ChooseFont(FontRec)#0 THEN
        Font := W.CreateFontIndirect(LogFont);
        SYSTEM.MOVE(SYSTEM.ADR(LogFont.lfFaceName),SYSTEM.ADR(FontName),LEN(LogFont.lfFaceName));
        RETURN TRUE;
      ELSE
        RETURN FALSE;
      END;
    END Execute;
      
  END;

  TPrintDialog* = POINTER TO RECORD
    VAR
      PrintRec: PRINTDLGA;
           
    PROCEDURE &Create*(AOwner: SYSTEM.PTR);
    BEGIN
      PrintRec.lStructSize := SIZE(PRINTDLGA);
      PrintRec.hwndOwner   := 0;
      PrintRec.hDevMode    := 0;
      PrintRec.hDevNames   := 0;
      PrintRec.Flags       := PD_USEDEVMODECOPIESANDCOLLATE + PD_RETURNDC; 
      PrintRec.nCopies     := 1;
      PrintRec.nFromPage   := -1; 
      PrintRec.nToPage     := -1; 
      PrintRec.nMinPage    := 1; 
      PrintRec.nMaxPage    := -1;
    END Create;
    
    PROCEDURE Execute* (): BOOLEAN;
    BEGIN
      IF PrintDlg(PrintRec)#0 THEN
        W.DeleteDC(PrintRec.hDC);
        RETURN TRUE;
      ELSE
        RETURN FALSE;
      END;
    END Execute;
      
  END;
    
VAR
  GetOpenFileName- : PROCEDURE [WINAPI] (VAR p0: OPENFILENAMEA): W.BOOL;
  GetSaveFileName- : PROCEDURE [WINAPI] (VAR p0: OPENFILENAMEA): W.BOOL;
  ChooseColor-     : PROCEDURE [WINAPI] (VAR p0: CHOOSECOLORA): W.BOOL;
  ChooseFont-      : PROCEDURE [WINAPI] (VAR p0: CHOOSEFONTA): W.BOOL;
  PrintDlg-        : PROCEDURE [WINAPI] (VAR p0: PRINTDLGA): W.BOOL;
            
PROCEDURE ShowMessage*(msg: ARRAY OF CHAR);
BEGIN
  W.MessageBox(W.HWND_DESKTOP,msg,"System dialog.",W.MB_OK + W.MB_ICONEXCLAMATION);
END ShowMessage;

END Dialogs.