(*#####################################################*)
(*# Graphics for Oberon Portable Compiler and Linker  #*)
(*#     ( https://sourceforge.net/projects/opcl )     #*)
(*# Version 1.0 for Win32: 9x,NT,Me,2k,XP,2k3,Vista,7 #*)
(*#  It is free for commercial & non-commercial use.  #*)
(*#                                                   #*)
(*# Copyright (C) 2011-2012, Serg Atantsov            #*)
(*#     e-mail Web_2.0@mail.ru     ICQ 200972129      #*)
(*#                                                   #*)
(*# Copyright (C) 2007-2012, Oleg N. Cher             #*)
(*#  www.zx.oberon2.ru e-mail allot@bk.ru ICQ 2208403 #*)
(*#####################################################*)

MODULE Graphics;

IMPORT
  SYSTEM, W:=Windows;

CONST
  fsBold*                          = 1;
  fsItalic*                        = 2;
  fsUnderline*                     = 3;
  fsStrikeOut*                     = 4;

  bsSolid*                         = 10;
  bsClear*                         = 11;
  bsHorizontal*                    = 0;
  bsVertical*                      = 1;
  bsFDiagonal*                     = 2;
  bsBDiagonal*                     = 3;
  bsCross*                         = 4;
  bsDiagCross*                     = 5;

  psSolid*                         = 0;
  psDash*                          = 1;
  psDot*                           = 2;
  psDashDot*                       = 3;
  psDashDotDot*                    = 4;
  psClear*                         = 5;
  psInsideFrame*                   = 6;
  psUserStyle*                     = 7;
  psAlternate*                     = 8;

  clBlack*                         = 0000000H;
  clMaroon*                        = 0000080H;
  clGreen*                         = 0008000H;
  clOlive*                         = 0008080H;
  clNavy*                          = 0800000H;
  clPurple*                        = 0800080H;
  clTeal*                          = 0808000H;
  clGray*                          = 0808080H;
  clSilver*                        = 0C0C0C0H;
  clRed*                           = 00000FFH;
  clLime*                          = 000FF00H;
  clYellow*                        = 000FFFFH;
  clBlue*                          = 0FF0000H;
  clFuchsia*                       = 0FF00FFH;
  clAqua*                          = 0FFFF00H;
  clLtGray*                        = 0C0C0C0H;
  clDkGray*                        = 0808080H;
  clWhite*                         = 0FFFFFFH;
  StandardColorsCount*             = 16;

  clMoneyGreen*                    = 0C0DCC0H;
  clSkyBlue*                       = 0F0CAA6H;
  clCream*                         = 0F0FBFFH;
  clMedGray*                       = 0A4A0A0H;
  ExtendedColorsCount*             = 4;

  clNone*                          = 01FFFFFFFH;
  clDefault*                       = 020000000H;


  clWebSnow*                       = 0FAFAFFH;
  clWebFloralWhite*                = 0F0FAFFH;
  clWebLavenderBlush*              = 0F5F0FFH;
  clWebOldLace*                    = 0E6F5FDH;
  clWebIvory*                      = 0F0FFFFH;
  clWebCornSilk*                   = 0DCF8FFH;
  clWebBeige*                      = 0DCF5F5H;
  clWebAntiqueWhite*               = 0D7EBFAH;
  clWebWheat*                      = 0B3DEF5H;
  clWebAliceBlue*                  = 0FFF8F0H;
  clWebGhostWhite*                 = 0FFF8F8H;
  clWebLavender*                   = 0FAE6E6H;
  clWebSeashell*                   = 0EEF5FFH;
  clWebLightYellow*                = 0E0FFFFH;
  clWebPapayaWhip*                 = 0D5EFFFH;
  clWebNavajoWhite*                = 0ADDEFFH;
  clWebMoccasin*                   = 0B5E4FFH;
  clWebBurlywood*                  = 087B8DEH;
  clWebAzure*                      = 0FFFFF0H;
  clWebMintcream*                  = 0FAFFF5H;
  clWebHoneydew*                   = 0F0FFF0H;
  clWebLinen*                      = 0E6F0FAH;
  clWebLemonChiffon*               = 0CDFAFFH;
  clWebBlanchedAlmond*             = 0CDEBFFH;
  clWebBisque*                     = 0C4E4FFH;
  clWebPeachPuff*                  = 0B9DAFFH;
  clWebTan*                        = 08CB4D2H;

  clWebYellow*                     = 000FFFFH;
  clWebDarkOrange*                 = 0008CFFH;
  clWebRed*                        = 00000FFH;
  clWebDarkRed*                    = 000008BH;
  clWebMaroon*                     = 0000080H;
  clWebIndianRed*                  = 05C5CCDH;
  clWebSalmon*                     = 07280FAH;
  clWebCoral*                      = 0507FFFH;
  clWebGold*                       = 000D7FFH;
  clWebTomato*                     = 04763FFH;
  clWebCrimson*                    = 03C14DCH;
  clWebBrown*                      = 02A2AA5H;
  clWebChocolate*                  = 01E69D2H;
  clWebSandyBrown*                 = 060A4F4H;
  clWebLightSalmon*                = 07AA0FFH;
  clWebLightCoral*                 = 08080F0H;
  clWebOrange*                     = 000A5FFH;
  clWebOrangeRed*                  = 00045FFH;
  clWebFirebrick*                  = 02222B2H;
  clWebSaddleBrown*                = 013458BH;
  clWebSienna*                     = 02D52A0H;
  clWebPeru*                       = 03F85CDH;
  clWebDarkSalmon*                 = 07A96E9H;
  clWebRosyBrown*                  = 08F8FBCH;

  clWebPaleGoldenrod*              = 0AAE8EEH;
  clWebLightGoldenrodYellow*       = 0D2FAFAH;
  clWebOlive*                      = 0008080H;
  clWebForestGreen*                = 0228B22H;
  clWebGreenYellow*                = 02FFFADH;
  clWebChartreuse*                 = 000FF7FH;
  clWebLightGreen*                 = 090EE90H;
  clWebAquamarine*                 = 0D4FF7FH;
  clWebSeaGreen*                   = 0578B2EH;
  clWebGoldenRod*                  = 020A5DAH;
  clWebKhaki*                      = 08CE6F0H;
  clWebOliveDrab*                  = 0238E6BH;
  clWebGreen*                      = 0008000H;
  clWebYellowGreen*                = 032CD9AH;
  clWebLawnGreen*                  = 000FC7CH;
  clWebPaleGreen*                  = 098FB98H;
  clWebMediumAquamarine*           = 0AACD66H;
  clWebMediumSeaGreen*             = 071B33CH;
  clWebDarkGoldenRod*              = 00B86B8H;
  clWebDarkKhaki*                  = 06BB7BDH;
  clWebDarkOliveGreen*             = 02F6B55H;
  clWebDarkgreen*                  = 0006400H;
  clWebLimeGreen*                  = 032CD32H;
  clWebLime*                       = 000FF00H;
  clWebSpringGreen*                = 07FFF00H;
  clWebMediumSpringGreen*          = 09AFA00H;
  clWebDarkSeaGreen*               = 08FBC8FH;

  clWebLightSeaGreen*              = 0AAB220H;
  clWebPaleTurquoise*              = 0EEEEAFH;
  clWebLightCyan*                  = 0FFFFE0H;
  clWebLightBlue*                  = 0E6D8ADH;
  clWebLightSkyBlue*               = 0FACE87H;
  clWebCornFlowerBlue*             = 0ED9564H;
  clWebDarkBlue*                   = 08B0000H;
  clWebIndigo*                     = 082004BH;
  clWebMediumTurquoise*            = 0CCD148H;
  clWebTurquoise*                  = 0D0E040H;
  clWebCyan*                       = 0FFFF00H;
  clWebAqua*                       = 0FFFF00H;
  clWebPowderBlue*                 = 0E6E0B0H;
  clWebSkyBlue*                    = 0EBCE87H;
  clWebRoyalBlue*                  = 0E16941H;
  clWebMediumBlue*                 = 0CD0000H;
  clWebMidnightBlue*               = 0701919H;
  clWebDarkTurquoise*              = 0D1CE00H;
  clWebCadetBlue*                  = 0A09E5FH;
  clWebDarkCyan*                   = 08B8B00H;
  clWebTeal*                       = 0808000H;
  clWebDeepskyBlue*                = 0FFBF00H;
  clWebDodgerBlue*                 = 0FF901EH;
  clWebBlue*                       = 0FF0000H;
  clWebNavy*                       = 0800000H;

  clWebDarkViolet*                 = 0D30094H;
  clWebDarkOrchid*                 = 0CC3299H;
  clWebMagenta*                    = 0FF00FFH;
  clWebFuchsia*                    = 0FF00FFH;
  clWebDarkMagenta*                = 08B008BH;
  clWebMediumVioletRed*            = 08515C7H;
  clWebPaleVioletRed*              = 09370DBH;
  clWebBlueViolet*                 = 0E22B8AH;
  clWebMediumOrchid*               = 0D355BAH;
  clWebMediumPurple*               = 0DB7093H;
  clWebPurple*                     = 0800080H;
  clWebDeepPink*                   = 09314FFH;
  clWebLightPink*                  = 0C1B6FFH;
  clWebViolet*                     = 0EE82EEH;
  clWebOrchid*                     = 0D670DAH;
  clWebPlum*                       = 0DDA0DDH;
  clWebThistle*                    = 0D8BFD8H;
  clWebHotPink*                    = 0B469FFH;
  clWebPink*                       = 0CBC0FFH;

  clWebLightSteelBlue*             = 0DEC4B0H;
  clWebMediumSlateBlue*            = 0EE687BH;
  clWebLightSlateGray*             = 0998877H;
  clWebWhite*                      = 0FFFFFFH;
  clWebLightgrey*                  = 0D3D3D3H;
  clWebGray*                       = 0808080H;
  clWebSteelBlue*                  = 0B48246H;
  clWebSlateBlue*                  = 0CD5A6AH;
  clWebSlateGray*                  = 0908070H;
  clWebWhiteSmoke*                 = 0F5F5F5H;
  clWebSilver*                     = 0C0C0C0H;
  clWebDimGray*                    = 0696969H;
  clWebMistyRose*                  = 0E1E4FFH;
  clWebDarkSlateBlue*              = 08B3D48H;
  clWebDarkSlategray*              = 04F4F2FH;
  clWebGainsboro*                  = 0DCDCDCH;
  clWebDarkGray*                   = 0A9A9A9H;
  clWebBlack*                      = 0000000H;

VAR
  clSystemColor*,clScrollBar*,clBackground*,clActiveCaption*,
  clInactiveCaption*,clMenu*,clWindow*,clWindowFrame*,clMenuText*,
  clWindowText*,clCaptionText*,clActiveBorder*,clInactiveBorder*,
  clAppWorkSpace*,clHighlight*,clHighlightText*,clBtnFace*,
  clBtnShadow*,clGrayText*,clBtnText*,clInactiveCaptionText*,
  clBtnHighlight*,cl3DDkShadow*,cl3DLight*,clInfoText*,clInfoBk*: W.COLORREF;
    
TYPE
    Integer = LONGINT;
    String  = ARRAY OF CHAR;

	TFont* = POINTER TO RECORD
    Handle*   : W.HFONT;  
    Color*    : Integer;
    Height*   : Integer;
    Name*     : ARRAY 32 OF CHAR;

    LogicFont : W.LOGFONT;

    PROCEDURE CreateFont;
    BEGIN
      Handle := W.CreateFont(
         LogicFont.lfHeight, 
         LogicFont.lfWidth, 
         LogicFont.lfEscapement, 
         LogicFont.lfOrientation, 
         LogicFont.lfWeight, 
         LogicFont.lfItalic, 
         LogicFont.lfUnderline, 
         LogicFont.lfStrikeOut, 
         LogicFont.lfCharSet,
         LogicFont.lfOutPrecision, 
         LogicFont.lfClipPrecision, 
         LogicFont.lfQuality,
         LogicFont.lfPitchAndFamily, 
         LogicFont.lfFaceName
      );      
    END CreateFont;
    
    PROCEDURE Create* (FontName : String);
    BEGIN
      COPY(FontName,SELF.Name);
      Height := 14;
      Color := 0;
  		LogicFont.lfHeight          := -Height;               (*      *)
  		LogicFont.lfWidth           := 0;                     (*       *)
  		LogicFont.lfEscapement      := 0;                     (*  ,      X  *)
  		LogicFont.lfOrientation     := 0;                     (*  ,        X  *)
  		LogicFont.lfWeight          := W.FW_REGULAR;          (*       0  1000 *)
  		LogicFont.lfItalic          := 0;                     (*    *)
  		LogicFont.lfUnderline       := 0;                     (*    *)
  		LogicFont.lfStrikeOut       := 0;                     (*    *)
  		LogicFont.lfCharSet         := W.DEFAULT_CHARSET;     (*    *)
  		LogicFont.lfOutPrecision    := W.OUT_DEFAULT_PRECIS;  (*    *)
  		LogicFont.lfClipPrecision   := W.CLIP_DEFAULT_PRECIS; (*    *)
  		LogicFont.lfQuality         := W.DEFAULT_QUALITY;     (*    *)
  		LogicFont.lfPitchAndFamily  := W.DEFAULT_PITCH;       (*       *)
  		LogicFont.lfFaceName        := SYSTEM.ADR(SELF.Name); (*     *)
      CreateFont;  
    END Create;

    PROCEDURE SetStyle* (Style: SET);
    BEGIN
      LogicFont.lfWeight    := W.FW_NORMAL;
      LogicFont.lfItalic    := 0;
      LogicFont.lfUnderline := 0;
      LogicFont.lfStrikeOut := 0;
      IF fsBold       IN Style THEN LogicFont.lfWeight    := W.FW_BOLD; END;
      IF fsItalic     IN Style THEN LogicFont.lfItalic    := 1;         END;
      IF fsUnderline  IN Style THEN LogicFont.lfUnderline := 1;         END;
      IF fsStrikeOut  IN Style THEN LogicFont.lfStrikeOut := 1;         END;    
      CreateFont;
    END SetStyle;

    PROCEDURE GetStyle* (): SET;
    VAR
      Style: SET;
    BEGIN
      Style := {};
      IF LogicFont.lfWeight     = W.FW_BOLD   THEN INCL(Style,fsBold);      END;
      IF LogicFont.lfItalic     = 1           THEN INCL(Style,fsItalic);    END;
      IF LogicFont.lfUnderline  = 1           THEN INCL(Style,fsUnderline); END;
      IF LogicFont.lfStrikeOut  = 1           THEN INCL(Style,fsStrikeOut); END;
      RETURN Style;
    END GetStyle;

    PROCEDURE SetName* (FontName : String);
    BEGIN
      COPY(FontName,SELF.Name);
      LogicFont.lfFaceName := SYSTEM.ADR(SELF.Name);
      CreateFont;
    END SetName;

    PROCEDURE SetSize* (Size : Integer);
    BEGIN
      Height:=Size;
      LogicFont.lfHeight := -Height;
      CreateFont;
    END SetSize;

    PROCEDURE SetColor* (FontColor : Integer);
    BEGIN
      IF Color # FontColor THEN Color:=FontColor; END;
      CreateFont;
    END SetColor;

	END;

    TPen* = POINTER TO RECORD
      Handle*   : W.HPEN;
      Color*    : Integer;
      Width*    : Integer;
      Style*    : Integer;
      LogPen    : W.LOGPEN;

      PROCEDURE Create* ();
      BEGIN
        SELF.Color:=0;
        SELF.Width:=1;
        SELF.Style:=psSolid;
        LogPen.lopnStyle    := SELF.Style;
        LogPen.lopnWidth.x  := SELF.Width;
        LogPen.lopnColor    := SELF.Color;
        Handle := W.CreatePenIndirect(LogPen);
      END Create;

      PROCEDURE SetWidth* (Width : Integer);
      BEGIN
        SELF.Width:=Width;
        LogPen.lopnWidth.x  := SELF.Width;
        Handle := W.CreatePenIndirect(LogPen);
      END SetWidth;

      PROCEDURE SetColor* (Color : W.COLORREF);
      BEGIN
        SELF.Color:=Color;
        LogPen.lopnColor    := SELF.Color;
        Handle := W.CreatePenIndirect(LogPen);
      END SetColor;

      PROCEDURE SetStyle* (Style : Integer);
      BEGIN
        SELF.Style:=Style;
        LogPen.lopnStyle    := SELF.Style;
        Handle := W.CreatePenIndirect(LogPen);
      END SetStyle;

    END;

    TBrush* = POINTER TO RECORD
      Handle*   : W.HBRUSH;
      Color*    : Integer;
      Style*    : Integer;
      LogBrush  : W.LOGBRUSH;

      PROCEDURE Create* ();
      BEGIN
        SELF.Color:= 0EFEFEFH;
        SELF.Style:= W.BS_SOLID;
        LogBrush.lbStyle := SELF.Style;
        LogBrush.lbColor := SELF.Color;
        LogBrush.lbHatch := 0;
        Handle := W.CreateBrushIndirect(LogBrush);
      END Create;

      PROCEDURE SetColor* (Color : W.COLORREF);
      BEGIN
        SELF.Color:=Color;
        LogBrush.lbColor:=SELF.Color;
        Handle := W.CreateBrushIndirect(LogBrush);
      END SetColor;

      PROCEDURE SetStyle* (Style : Integer);
      BEGIN
        SELF.Style:= Style;
        CASE SELF.Style OF
          bsSolid: LogBrush.lbStyle := W.BS_SOLID;
        | bsClear: LogBrush.lbStyle := W.BS_HOLLOW;
        ELSE
          LogBrush.lbStyle := W.BS_HATCHED;
          LogBrush.lbHatch := SELF.Style - bsHorizontal;
        END;
        Handle := W.CreateBrushIndirect(LogBrush);
      END SetStyle;

    END;

    TCanvas* = POINTER TO RECORD
      Handle*         : W.HDC;
      Color*          : Integer;
      Font*           : TFont;
      Pen*            : TPen;
      Brush*          : TBrush;
      DoubleBuffer*   : BOOLEAN;

      Parent          : W.HWND;
      hMemDc          : W.HDC;
      hMemBmp         : W.HBITMAP;
      ps              : W.PAINTSTRUCT;

      CONST
        dmPen   = 1;
        dmBrush = 2;
        dmFont  = 3;

      PROCEDURE Create* (DBuffer: BOOLEAN);
      BEGIN
        SELF.Handle:= W.BeginPaint(Parent,ps);

        IF SELF.Parent=0 THEN W.Shutdown(); END;
        (*ASSERT(SELF.Parent#0);*)

        SELF.DoubleBuffer:=DBuffer;
        IF DoubleBuffer THEN
          hMemDc  := W.CreateCompatibleDC(Handle);
          hMemBmp := W.CreateCompatibleBitmap(Handle,W.GetDeviceCaps(Handle, W.HORZRES),W.GetDeviceCaps(Handle, W.VERTRES));
	        W.SelectObject(hMemDc, hMemBmp);
        ELSE
          hMemDc:=Handle;
        END;

        NEW(Font);
  	    Font.Create("");
  
  	    NEW(Pen);
  	    Pen.Create();
  	
  	    NEW(Brush);
  	    Brush.Create();

        W.SetBkMode(hMemDc, W.OPAQUE);
        SetColor(clWhite);
      END Create;

      PROCEDURE & SetParent* (Parent: W.HWND);
      BEGIN
        SELF.Parent := Parent;
      END SetParent;

      PROCEDURE SetColor* (Color: W.COLORREF);
      BEGIN
        IF SELF.Color#Color THEN SELF.Color:=Color; END;
        Brush.SetColor(Color);
        DrawMode({dmBrush});
        W.PatBlt(hMemDc,0,0,W.GetDeviceCaps(Handle, W.HORZRES),W.GetDeviceCaps(Handle, W.VERTRES),W.PATCOPY);
      END SetColor;
      
      PROCEDURE DrawMode(mode: SET);
      BEGIN
        IF dmFont IN mode THEN
          W.SetTextColor(hMemDc, Font.Color);
          W.SelectObject(hMemDc, Font.Handle);
        END;
        IF dmBrush IN mode THEN
          W.SelectObject(hMemDc, Brush.Handle);
        END;
        IF dmPen IN mode THEN
          W.SelectObject(hMemDc, Pen.Handle);
        END;
      END DrawMode;

      PROCEDURE Mode* (mode: Integer);
      BEGIN
        IF mode=W.OPAQUE THEN
          W.SetBkMode(hMemDc, W.OPAQUE);
        ELSE
          W.SetBkMode(hMemDc, W.TRANSPARENT);
        END;
      END Mode;

      PROCEDURE Length (str: String): Integer;
  	  VAR
  	    len, maxLen: Integer;
  	  BEGIN
  	    maxLen := LEN(str);
  	    len := 0;
  	    WHILE (len < maxLen) & (str[len] # 0X) DO INC(len) END;
  	    RETURN len;
  	  END Length;

      PROCEDURE TextOut* (X,Y : Integer; Text: String);
      VAR
        R: W.RECT;
        S: W.TSIZE;
      BEGIN
        DrawMode({dmFont});
        W.ExtTextOut(hMemDc, X, Y, W.ETO_CLIPPED, NIL, SYSTEM.ADR(Text),Length(Text), NIL);
      END TextOut;

      PROCEDURE DrawText* (R: W.RECT; Text: String);
      BEGIN
        DrawMode({dmFont});
        W.DrawText(hMemDc, SYSTEM.ADR(Text), -1, R, W.DT_VCENTER + W.DT_LEFT);
      END DrawText;

      PROCEDURE MoveTo* (X,Y: Integer);
      BEGIN
        W.MoveToEx(hMemDc,X,Y,NIL);
      END MoveTo;

      PROCEDURE LineTo* (X,Y: Integer);
      BEGIN
        DrawMode({dmPen,dmBrush});
        W.LineTo(hMemDc,X,Y);
      END LineTo;

      PROCEDURE Ellipse* (X1,Y1,X2,Y2: Integer);
      BEGIN
        DrawMode({dmPen,dmBrush});
        W.Ellipse(hMemDc, X1, Y1, X2, Y2);
      END Ellipse;

      PROCEDURE Rectangle* (X1,Y1,X2,Y2: Integer);
      BEGIN
        DrawMode({dmPen,dmBrush});
        W.Rectangle(hMemDc, X1, Y1, X2, Y2);
      END Rectangle;

      PROCEDURE RoundRect* (X1,Y1,X2,Y2,AX,AY: Integer);
      BEGIN
        DrawMode({dmPen,dmBrush});
        W.RoundRect(hMemDc, X1, Y1, X2, Y2, AX, AY);
      END RoundRect;

      PROCEDURE Fill* ();
      BEGIN
        DrawMode({dmBrush});
		    W.PatBlt(hMemDc,0,0,W.GetDeviceCaps(Handle, W.HORZRES),W.GetDeviceCaps(Handle, W.VERTRES),W.PATCOPY);
      END Fill;

      PROCEDURE Release* ();
      BEGIN
        IF DoubleBuffer THEN
          W.BitBlt(Handle, 0, 0, W.GetDeviceCaps(Handle, W.HORZRES), W.GetDeviceCaps(Handle, W.VERTRES), hMemDc, 0,0, W.SRCCOPY);
          W.DeleteDC(hMemDc);
          W.DeleteObject(hMemBmp);
        END;

        W.DeleteObject(Brush.Handle);
        W.DeleteObject(Font.Handle);
        W.DeleteObject(Pen.Handle);

        W.DeleteDC(Handle);
		    W.ReleaseDC(Parent,Handle);
        W.EndPaint(Parent,ps);
      END Release;

    END;

BEGIN
  clScrollBar                     := W.GetSysColor(W.COLOR_SCROLLBAR);
  clBackground                    := W.GetSysColor(W.COLOR_BACKGROUND);
  clActiveCaption                 := W.GetSysColor(W.COLOR_ACTIVECAPTION);
  clInactiveCaption               := W.GetSysColor(W.COLOR_INACTIVECAPTION);
  clMenu                          := W.GetSysColor(W.COLOR_MENU);
  clWindow                        := W.GetSysColor(W.COLOR_WINDOW);
  clWindowFrame                   := W.GetSysColor(W.COLOR_WINDOWFRAME);
  clMenuText                      := W.GetSysColor(W.COLOR_MENUTEXT);
  clWindowText                    := W.GetSysColor(W.COLOR_WINDOWTEXT);
  clCaptionText                   := W.GetSysColor(W.COLOR_CAPTIONTEXT);
  clActiveBorder                  := W.GetSysColor(W.COLOR_ACTIVEBORDER);
  clInactiveBorder                := W.GetSysColor(W.COLOR_INACTIVEBORDER);
  clAppWorkSpace                  := W.GetSysColor(W.COLOR_APPWORKSPACE);
  clHighlight                     := W.GetSysColor(W.COLOR_HIGHLIGHT);
  clHighlightText                 := W.GetSysColor(W.COLOR_HIGHLIGHTTEXT);
  clBtnFace                       := W.GetSysColor(W.COLOR_BTNFACE);
  clBtnShadow                     := W.GetSysColor(W.COLOR_BTNSHADOW);
  clGrayText                      := W.GetSysColor(W.COLOR_GRAYTEXT);
  clBtnText                       := W.GetSysColor(W.COLOR_BTNTEXT);
  clInactiveCaptionText           := W.GetSysColor(W.COLOR_INACTIVECAPTIONTEXT);
  clBtnHighlight                  := W.GetSysColor(W.COLOR_BTNHIGHLIGHT);
  cl3DDkShadow                    := W.GetSysColor(W.COLOR_3DDKSHADOW);
  cl3DLight                       := W.GetSysColor(W.COLOR_3DLIGHT);
  clInfoText                      := W.GetSysColor(W.COLOR_INFOTEXT);
  clInfoBk                        := W.GetSysColor(W.COLOR_INFOBK);
END Graphics.
